Qore Programming Language Reference Manual: Qore::HashIterator Class Reference

Qore Programming Language Reference Manual 0.8.11

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Variables Groups Pages
Public Member Functions | List of all members
Qore::HashIterator Class Reference

This class an iterator class for hashes. More...

Inheritance diagram for Qore::HashIterator:
[legend]

## Public Member Functions
| constructor (hash h)
| Creates the hash iterator object. More...
| constructor ()
| Creates an empty hash iterator object. More...
| copy ()
| Creates a copy of the HashIterator object, iterating the same object as the original and in the same position. More...
bool | empty ()
| returns True if the hash is empty; False if not More...
bool | first ()
| returns True if on the first element of the hash More...
string | getKey ()
| returns the current key value or throws an `INVALID-ITERATOR` exception if the iterator is invalid More...
any | getKeyValue ()
| returns the current value of the current has key being iterated or throws an `INVALID-ITERATOR` exception if the iterator is invalid More...
any | getValue ()
| returns the current key value or throws an `INVALID-ITERATOR` exception if the iterator is invalid More...
hash | getValuePair ()
| returns a hash with the current key and value (a hash with 2 keys: `"key"` and `"value"`) or throws an `INVALID-ITERATOR` exception if the iterator is invalid More...
bool | last ()
| returns True if on the last element of the hash More...
bool | next ()
| Moves the current position to the next element in the hash; returns False if there are no more elements; if the iterator is not pointing at a valid element before this call, the iterator will be positioned on the first element in the hash if the hash is not empty. More...
bool | prev ()
| Moves the current position to the previous element in the hash; returns False if there are no more elements; if the iterator is not pointing at a valid element before this call, the iterator will be positioned on the last element in the hash if the hash is not empty. More...
| reset ()
| Reset the iterator instance to its initial state. More...
bool | valid ()
| returns True if the iterator is currently pointing at a valid element, False if not More...

## Detailed Description

This class an iterator class for hashes.

Call HashIterator::next() to iterate through the hash; do not use the iterator if HashIterator::next() returns False. A hash can be iterated in reverse order by calling HashIterator::prev() instead of HashIterator::next()

Example: HashIterator basic usage
  my hash $h = ( "key1" : 1, "key2" : 2, );
  my HashIterator $it($h);
  while ($it.next()) {
  printf("getKey: %n; getKeyValue: %n; getValue: %n; getValuePair: %n\n",
  $it.getKey(), $it.getKeyValue(), $it.getValue(), $it.getValuePair());
  }
  getKey: "key1"; getKeyValue: 1; getValue: 1; getValuePair: hash: (key : "key1", value : 1)
  getKey: "key2"; getKeyValue: 2; getValue: 2; getValuePair: hash: (key : "key2", value : 2)

Note
  - In general, the HashIterator class is not designed to be accessed from multiple threads; it was created without locking for fast and efficient use when used from a single thread. For methods that would be unsafe to use in another thread, any use of such methods in threads other than the thread where the constructor was called will cause an `ITERATOR-THREAD-ERROR` to be thrown.

See Also
  HashReverseIterator

## Member Function Documentation

Qore::HashIterator::constructor | ( | hash | h | ) |

Creates the hash iterator object.

Parameters

  h | the hash to iterate

Example:
  my HashIterator $hi($h);

Qore::HashIterator::constructor | ( |  | ) |

Creates an empty hash iterator object.

Example:
  my *hash $h = get_hash_or_nothing();
  my HashIterator $hi($h);

Qore::HashIterator::copy | ( |  | ) |

Creates a copy of the HashIterator object, iterating the same object as the original and in the same position.

Example:
  my HashIterator $ni = $i.copy();

bool Qore::HashIterator::empty | ( |  | ) |
| virtual

returns True if the hash is empty; False if not

Returns
  True if the hash is empty; False if not

Code Flags:
  CONSTANT

Example:
  if ($i.empty())
  printf("the hash is empty\n");

Implements Qore::AbstractQuantifiedIterator.

bool Qore::HashIterator::first | ( |  | ) |
| virtual

returns True if on the first element of the hash

Returns
  True if on the first element of the hash

Code Flags:
  CONSTANT

Example:
  while ($i.next()) {
  if ($i.first())
  printf("START:\n");
  }

Implements Qore::AbstractQuantifiedIterator.

Reimplemented in Qore::ObjectReverseIterator, and Qore::HashReverseIterator.

string Qore::HashIterator::getKey | ( |  | ) |

returns the current key value or throws an `INVALID-ITERATOR` exception if the iterator is invalid

Returns
  the current key value or throws an `INVALID-ITERATOR` exception if the iterator is invalid

Code Flags:
  RET_VALUE_ONLY

Example:
  while ($i.next()) {
  printf("+ %y\n", $i.getKey());
  }

Exceptions

  INVALID-ITERATOR | the iterator is not pointing at a valid element
  ITERATOR-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

any Qore::HashIterator::getKeyValue | ( |  | ) |

returns the current value of the current has key being iterated or throws an `INVALID-ITERATOR` exception if the iterator is invalid

Returns
  the current value of the current has key being iterated or throws an `INVALID-ITERATOR` exception if the iterator is invalid

Code Flags:
  RET_VALUE_ONLY

Example:
  while ($i.next()) {
  printf("+ %y\n", $i.getKeyValue());
  }

Exceptions

  INVALID-ITERATOR | the iterator is not pointing at a valid element
  ITERATOR-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

Since
  Qore 0.8.6

any Qore::HashIterator::getValue | ( |  | ) |
| virtual

returns the current key value or throws an `INVALID-ITERATOR` exception if the iterator is invalid

The current hash key can be returned with getKey().

Returns
  the current key value or throws an `INVALID-ITERATOR` exception if the iterator is invalid

Code Flags:
  RET_VALUE_ONLY

Example:
  while ($i.next()) {
  printf("+ %y\n", $i.getValue());
  }

Exceptions

  INVALID-ITERATOR | the iterator is not pointing at a valid element
  ITERATOR-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

Implements Qore::AbstractIterator.

Reimplemented in Qore::ObjectPairReverseIterator, Qore::ObjectKeyReverseIterator, Qore::HashKeyReverseIterator, Qore::HashPairReverseIterator, Qore::ObjectPairIterator, Qore::ObjectKeyIterator, Qore::HashPairIterator, and Qore::HashKeyIterator.

hash Qore::HashIterator::getValuePair | ( |  | ) |

returns a hash with the current key and value (a hash with 2 keys: `"key"` and `"value"`) or throws an `INVALID-ITERATOR` exception if the iterator is invalid

Returns
  a hash with the current key and value (a hash with 2 keys: `"key"` and `"value"`) or throws an `INVALID-ITERATOR` exception if the iterator is invalid

Code Flags:
  RET_VALUE_ONLY

Example:
  while ($i.next()) {
  printf("+ %y\n", $i.getValuePair());
  }

Exceptions

  INVALID-ITERATOR | the iterator is not pointing at a valid element
  ITERATOR-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

Since
  Qore 0.8.6

bool Qore::HashIterator::last | ( |  | ) |
| virtual

returns True if on the last element of the hash

Returns
  True if on the last element of the hash

Code Flags:
  CONSTANT

Example:
  while ($i.next()) {
  if ($i.last())
  printf("END.\n");
  }

Implements Qore::AbstractQuantifiedIterator.

Reimplemented in Qore::ObjectReverseIterator, and Qore::HashReverseIterator.

bool Qore::HashIterator::next | ( |  | ) |
| virtual

Moves the current position to the next element in the hash; returns False if there are no more elements; if the iterator is not pointing at a valid element before this call, the iterator will be positioned on the first element in the hash if the hash is not empty.

This method will return True again after it returns False once if hash is not empty, otherwise it will always return False. The iterator object should not be used after this method returns False

Returns
  False if there are no more elements in the hash (in which case the iterator object is invalid and should not be used); True if successful (meaning that the iterator object is valid)

Example:
  while ($i.next()) {
  printf(" + %y = %y\n", $i.getKey(), $i.getValue());
  }

Exceptions

  ITERATOR-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

Implements Qore::AbstractIterator.

Reimplemented in Qore::ObjectReverseIterator, and Qore::HashReverseIterator.

bool Qore::HashIterator::prev | ( |  | ) |
| virtual

Moves the current position to the previous element in the hash; returns False if there are no more elements; if the iterator is not pointing at a valid element before this call, the iterator will be positioned on the last element in the hash if the hash is not empty.

This method will return True again after it returns False once if the hash is not empty, otherwise it will always return False. The iterator object should not be used after this method returns False

Returns
  False if there are no more elements in the hash (in which case the iterator object is invalid and should not be used); True if successful (meaning that the iterator object is valid)

Example:
  while ($i.prev()) {
  printf(" + %y = %y\n", $i.getKey(), $i.getValue());
  }

Exceptions

  ITERATOR-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

Implements Qore::AbstractBidirectionalIterator.

Reimplemented in Qore::ObjectReverseIterator, and Qore::HashReverseIterator.

Qore::HashIterator::reset | ( |  | ) |

Reset the iterator instance to its initial state.

Reset the iterator instance to its initial state

Example
  $i.reset();

Exceptions

  ITERATOR-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

bool Qore::HashIterator::valid | ( |  | ) |
| virtual

returns True if the iterator is currently pointing at a valid element, False if not

Returns
  True if the iterator is currently pointing at a valid element, False if not

Code Flags:
  CONSTANT

Example:
  if ($i.valid())
  printf("current value: %y\n", $i.getValue());

Implements Qore::AbstractIterator.